#include <cstdio>
#include <iostream>
#include <iomanip>

using namespace std;

constexpr int MAXN = 2e5;
int x[MAXN], y[MAXN], r[MAXN];

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int n, q;
    scanf(" %d %d", &n, &q);
    for (int i = 0; i < n + q; ++i) {
        scanf(" %d %d %d", &x[i], &y[i], &r[i]);
        for (int j = 0; j < i; ++j) {
            long long dx = x[i] - x[j];
            long long dy = y[i] - y[j];
            long long dist2 = dx * dx + dy * dy;
            bool disjoint = dist2 > 1LL * (r[i] + r[j]) * (r[i] + r[j]);
            bool nested = dist2 < 1LL * (r[i] - r[j]) * (r[i] - r[j]);
            if (!disjoint and !nested) {
                printf("Circle (%d, %d, %d) and (%d, %d, %d) intersect\n",
                        x[i], y[i], r[i], x[j], y[j], r[j]);
                return 43;
            }
        }
    }

    return 42;
}
