#include <iostream>
#include <vector>
#include <set>
#include <math.h>
using namespace std ;
using ll = long long ;
using pt = pair<ll, ll> ;
using circ = pair<pt, ll> ;
vector<circ> cv ;
int gx ;
int incirc(int a, int b) {
   ll dx = cv[a].first.first - cv[b].first.first ;
   ll dy = cv[a].first.second - cv[b].first.second ;
   return dx * dx + dy * dy <= cv[b].second * cv[b].second ;
}
double yat(int c, int bot) {
   double r = cv[c].second ;
   double dx = cv[c].first.first - gx ;
   double dy = sqrt(r*r-dx*dx) ;
   double rv ;
   if (bot)
      rv = cv[c].first.second + dy ;
   else
      rv = cv[c].first.second - dy ;
   return rv ;
}
struct ccmp {
   bool operator() (const pair<int, int> &a, const pair<int, int> &b) const {
      double ya = yat(a.first, a.second) ;
      double yb = yat(b.first, b.second) ;
      if (ya != yb)
         return ya < yb ;
      return a.second < b.second ;
   }
} ;
vector<vector<int>> child ;
vector<pair<int, int>> sols ;
pair<int, int> solve(int i, int n) {
   pair<int, int> r = {0, 0} ;
   r.first = 1 ;
   for (auto c: child[i]) {
      auto p = solve(c, n) ;
      if (c < n) { // actual circle; flip
         r.first += p.second ;
         r.second += max(p.first, p.second) ;
      } else { // query circle; sum
         r.first += p.first - 1 ;
         r.second += p.second ;
      }
   }
   sols[i] = r ;
   return r ;
}
int main() {
   int n, m ;
   cin >> n >> m ;
   cv.resize(n+m) ;
   set<pair<int, int> > sweep ;
   for (int i=0; i<n+m; i++) {
      auto &v = cv[i] ;
      cin >> v.first.first >> v.first.second >> v.second ;
      sweep.insert({v.first.first-v.second, i}) ;
      sweep.insert({v.first.first+v.second, i}) ;
   }
   set<pair<int, int>, ccmp> opencircs ;
   vector<int> parent(n+m) ;
   for (auto v: sweep) {
      int x = v.first ;
      int i = v.second ;
      gx = x ;
      if (x < cv[i].first.first) { // open a circle
         auto p = opencircs.lower_bound({i,0}) ;
         if (p == opencircs.end()) {
            parent[i] = m+n ;
         } else if (incirc(i, p->first)) {
            parent[i] = p->first ;
         } else {
            parent[i] = parent[p->first] ;
         }
         opencircs.insert({i, 0}) ;
         opencircs.insert({i, 1}) ;
      } else { // close a circle
         opencircs.erase({i, 0}) ;
         opencircs.erase({i, 1}) ;
      }
   }
   child.resize(n+m+1) ;
   for (int i=0; i<(int)parent.size(); i++)
      child[parent[i]].push_back(i) ;
   sols.resize(n+m+1) ;
   solve(m+n, n) ;
   for (int i=n; i<n+m; i++)
      cout << max(sols[i].first, sols[i].second) << endl ;
}
