import java.io.OutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.util.Arrays;
import java.io.BufferedWriter;
import java.io.Writer;
import java.io.OutputStreamWriter;
import java.util.InputMismatchException;
import java.io.IOException;
import java.io.InputStream;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 *
 * @author lewin
 */
public class grid_guardian_lewin {
    public static void main(String[] args) {
        InputStream inputStream = System.in;
        OutputStream outputStream = System.out;
        InputReader in = new InputReader(inputStream);
        OutputWriter out = new OutputWriter(outputStream);
        GridGuardian solver = new GridGuardian();
        solver.solve(1, in, out);
        out.close();
    }

    static class GridGuardian {
        public void solve(int testNumber, InputReader in, OutputWriter out) {
            int n = in.nextInt(), m = in.nextInt(), mod = in.nextInt();
            if (n % 2 == 1 && m % 2 == 1) {
                out.println(1);
                return;
            }
            if (n % 2 == 1) {
                out.println(Utils.mod_exp(m / 2 + 1, n / 2, mod));
                return;
            }
            if (m % 2 == 1) {
                out.println(Utils.mod_exp(n / 2 + 1, m / 2, mod));
                return;
            }
            n /= 2;
            m /= 2;
            if (m > n) {
                int t = n;
                n = m;
                m = t;
            }
            int[][][] submask = new int[m + 1][m + 1][1 << m];
            for (int i = 0; i <= m; i++) {
                for (int j = 0; j <= m; j++) {
                    for (int mask = 0; mask < 1 << m; mask++) {
                        submask[i][j][mask] = mask;
                        for (int k = j + 1; k <= i - 1; k++) {
                            if (((mask >> (k - 1)) & 1) == 0 && ((submask[i][j][mask] >> k) & 1) == 1) {
                                submask[i][j][mask] ^= 1 << k;
                            }
                        }
                        for (int k = i + 1; k <= j - 1; k++) {
                            if (((mask >> k) & 1) == 0 && ((submask[i][j][mask] >> (k - 1) & 1)) == 1) {
                                submask[i][j][mask] ^= 1 << (k - 1);
                            }
                        }
                    }
                }
            }
            int[][][] dp = new int[2][m + 1][1 << m];
            AUtils.deepFill(dp[0], 1);
            int ptr = 1;
            for (int i = 1; i < n; i++) {
                for (int j = 0; j <= m; j++) {
                    for (int level = 0; level < m; level++) {
                        for (int k = 0; k < 1 << m; k++) {
                            if (((k >> level) & 1) == 1) {
                                dp[1 - ptr][j][k] += dp[1 - ptr][j][k ^ (1 << level)];
                                if (dp[1 - ptr][j][k] >= mod) dp[1 - ptr][j][k] -= mod;
                            }
                        }
                    }
                }
                for (int j = 0; j <= m; j++) {
                    for (int k = 0; k < 1 << m; k++) {
                        dp[ptr][j][k] = dp[1 - ptr][0][submask[j][0][k]];
                        if (dp[ptr][j][k] >= mod) dp[ptr][j][k] -= mod;
                    }
                    for (int r = 1; r <= m; r++) {
                        for (int k = 0; k < 1 << m; k++) {
                            dp[ptr][j][k] += dp[1 - ptr][r][submask[j][r][k]];
                            if (dp[ptr][j][k] >= mod) dp[ptr][j][k] -= mod;
                        }
                    }
                }
                ptr = 1 - ptr;
            }
            int res = 0;
            for (int j = 0; j <= m; j++) {
                for (int i = 0; i < 1 << m; i++) {
                    res += dp[1 - ptr][j][i];
                    if (res >= mod) res -= mod;
                }
            }
            out.println(res);
        }

    }

    static class OutputWriter {
        private final PrintWriter writer;

        public OutputWriter(OutputStream outputStream) {
            writer = new PrintWriter(new BufferedWriter(new OutputStreamWriter(outputStream)));
        }

        public OutputWriter(Writer writer) {
            this.writer = new PrintWriter(writer);
        }

        public void close() {
            writer.close();
        }

        public void println(long i) {
            writer.println(i);
        }

        public void println(int i) {
            writer.println(i);
        }

    }

    static class AUtils {
        public static void deepFill(int[][] x, int val) {
            for (int[] y : x) deepFill(y, val);
        }

        public static void deepFill(int[] x, int val) {
            Arrays.fill(x, val);
        }

    }

    static class InputReader {
        private InputStream stream;
        private byte[] buf = new byte[1 << 16];
        private int curChar;
        private int numChars;

        public InputReader(InputStream stream) {
            this.stream = stream;
        }

        public int read() {
            if (this.numChars == -1) {
                throw new InputMismatchException();
            } else {
                if (this.curChar >= this.numChars) {
                    this.curChar = 0;

                    try {
                        this.numChars = this.stream.read(this.buf);
                    } catch (IOException var2) {
                        throw new InputMismatchException();
                    }

                    if (this.numChars <= 0) {
                        return -1;
                    }
                }

                return this.buf[this.curChar++];
            }
        }

        public int nextInt() {
            int c;
            for (c = this.read(); isSpaceChar(c); c = this.read()) {
                ;
            }

            byte sgn = 1;
            if (c == 45) {
                sgn = -1;
                c = this.read();
            }

            int res = 0;

            while (c >= 48 && c <= 57) {
                res *= 10;
                res += c - 48;
                c = this.read();
                if (isSpaceChar(c)) {
                    return res * sgn;
                }
            }

            throw new InputMismatchException();
        }

        public static boolean isSpaceChar(int c) {
            return c == 32 || c == 10 || c == 13 || c == 9 || c == -1;
        }

    }

    static class Utils {
        public static long mod_exp(long b, long e, long mod) {
            long res = 1;
            while (e > 0) {
                if ((e & 1) == 1)
                    res = (res * b) % mod;
                b = (b * b) % mod;
                e >>= 1;
            }
            return res % mod;
        }

    }
}

