import java.io.OutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.HashSet;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.io.BufferedWriter;
import java.io.Writer;
import java.io.OutputStreamWriter;
import java.util.HashMap;
import java.util.InputMismatchException;
import java.io.IOException;
import java.io.InputStream;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 *
 * @author lewin
 */
public class grid_guardian_lewin_bitmask {
    public static void main(String[] args) {
        InputStream inputStream = System.in;
        OutputStream outputStream = System.out;
        InputReader in = new InputReader(inputStream);
        OutputWriter out = new OutputWriter(outputStream);
        GridGuardianBitmask solver = new GridGuardianBitmask();
        solver.solve(1, in, out);
        out.close();
    }

    static class GridGuardianBitmask {
        int n;
        int m;
        int mod;
        HashMap<Long, Integer> mp;
        HashSet<Long> ss;

        long bit(long mask, int pos) {
            return ((mask >> (2L * pos)) & 3);
        }

        long unset(long mask, int pos) {
            return mask ^ (bit(mask, pos) << (2L * pos));
        }

        int dfs(int row, int col, long mask) {
            if (col == m) {
                ss.add(mask & ((1L << (2 * m)) - 1));
                return dfs(row + 1, 0, mask);
            }
            if (row == n) return 1;
            long t = mask * n * m + row * m + col;
            Integer g = mp.get(t);
            if (g != null) return g;
            int nways = 0;
            for (int i = 0; i < 4; i++) {
                if (col > 0 && (i & 1) == 1 && (bit(mask, col - 1) & 1) == 0) continue;
                if (row > 0 && (i & 2) == 2 && (bit(mask, col) & 2) == 0) continue;
                if (col > 0 && bit(mask, col - 1) == 3 && bit(mask, m) == 2 && bit(mask, col) == 0 && i == 1) continue;
                if (col > 0 && bit(mask, col - 1) == 0 && bit(mask, m) == 1 && bit(mask, col) == 3 && i == 2) continue;

                long nmask = unset(unset(mask, col), m) | (i << (2L * col)) | (bit(mask, col) << (2L * m));
                nways += dfs(row, col + 1, nmask);
                if (nways >= mod) nways -= mod;
            }
            mp.put(t, nways);
            return nways;
        }

        public void solve(int testNumber, InputReader in, OutputWriter out) {
            n = in.nextInt();
            m = in.nextInt();
            mod = in.nextInt();
            if (n % 2 == 1 && m % 2 == 1) {
                out.println(1);
                return;
            }
            if (n % 2 == 1) {
                out.println(Utils.mod_exp(m / 2 + 1, n / 2, mod));
                return;
            }
            if (m % 2 == 1) {
                out.println(Utils.mod_exp(n / 2 + 1, m / 2, mod));
                return;
            }
            n /= 2;
            m /= 2;
            if (m > n) {
                int t = n;
                n = m;
                m = t;
            }
            mp = new HashMap<>();
            ss = new HashSet<>();
            out.println(dfs(0, 0, (1L << (2 * m + 3)) - 1));
        }

    }

    static class OutputWriter {
        private final PrintWriter writer;

        public OutputWriter(OutputStream outputStream) {
            writer = new PrintWriter(new BufferedWriter(new OutputStreamWriter(outputStream)));
        }

        public OutputWriter(Writer writer) {
            this.writer = new PrintWriter(writer);
        }

        public void close() {
            writer.close();
        }

        public void println(long i) {
            writer.println(i);
        }

        public void println(int i) {
            writer.println(i);
        }

    }

    static class Utils {
        public static long mod_exp(long b, long e, long mod) {
            long res = 1;
            while (e > 0) {
                if ((e & 1) == 1)
                    res = (res * b) % mod;
                b = (b * b) % mod;
                e >>= 1;
            }
            return res % mod;
        }

    }

    static class InputReader {
        private InputStream stream;
        private byte[] buf = new byte[1 << 16];
        private int curChar;
        private int numChars;

        public InputReader(InputStream stream) {
            this.stream = stream;
        }

        public int read() {
            if (this.numChars == -1) {
                throw new InputMismatchException();
            } else {
                if (this.curChar >= this.numChars) {
                    this.curChar = 0;

                    try {
                        this.numChars = this.stream.read(this.buf);
                    } catch (IOException var2) {
                        throw new InputMismatchException();
                    }

                    if (this.numChars <= 0) {
                        return -1;
                    }
                }

                return this.buf[this.curChar++];
            }
        }

        public int nextInt() {
            int c;
            for (c = this.read(); isSpaceChar(c); c = this.read()) {
                ;
            }

            byte sgn = 1;
            if (c == 45) {
                sgn = -1;
                c = this.read();
            }

            int res = 0;

            while (c >= 48 && c <= 57) {
                res *= 10;
                res += c - 48;
                c = this.read();
                if (isSpaceChar(c)) {
                    return res * sgn;
                }
            }

            throw new InputMismatchException();
        }

        public static boolean isSpaceChar(int c) {
            return c == 32 || c == 10 || c == 13 || c == 9 || c == -1;
        }

    }
}

