import java.io.OutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.io.BufferedWriter;
import java.io.Writer;
import java.io.OutputStreamWriter;
import java.util.InputMismatchException;
import java.io.IOException;
import java.io.InputStream;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 *
 * @author lewin
 */
public class grid_guardian_lewin_brute_force {
    public static void main(String[] args) {
        InputStream inputStream = System.in;
        OutputStream outputStream = System.out;
        InputReader in = new InputReader(inputStream);
        OutputWriter out = new OutputWriter(outputStream);
        GridGuardianBrute solver = new GridGuardianBrute();
        solver.solve(1, in, out);
        out.close();
    }

    static class GridGuardianBrute {
        public void solve(int testNumber, InputReader in, OutputWriter out) {
            int n = in.nextInt(), m = in.nextInt(), p = in.nextInt();
            int mn = n * m;
            while (mn > 30) { // make verify problem happy
               mn = 2 * mn - mn ;
            }
            int ct = 0;
            for (int i = 0; i < 1 << (n * m); i++) {
                if (Integer.bitCount(i) > mn) continue;
                boolean[][] grid = new boolean[n][m];
                for (int j = 0; j < n; j++)
                    for (int k = 0; k < m; k++) {
                        grid[j][k] = ((i >> (j * m + k)) & 1) == 1;
                    }
                boolean ok = true;
                for (int j = 0; ok && j + 1 < n; j++)
                    for (int k = 0; ok && k + 1 < m; k++) {
                        if (!grid[j][k] && !grid[j + 1][k] && !grid[j][k + 1] && !grid[j + 1][k + 1]) {
                            ok = false;
                        }
                    }
                if (ok) {
                    if (Integer.bitCount(i) < mn) ct = 0;
                    mn = Integer.bitCount(i);
                    ct++;
                }
            }
            out.println(ct % p);
        }

    }

    static class OutputWriter {
        private final PrintWriter writer;

        public OutputWriter(OutputStream outputStream) {
            writer = new PrintWriter(new BufferedWriter(new OutputStreamWriter(outputStream)));
        }

        public OutputWriter(Writer writer) {
            this.writer = new PrintWriter(writer);
        }

        public void close() {
            writer.close();
        }

        public void println(int i) {
            writer.println(i);
        }

    }

    static class InputReader {
        private InputStream stream;
        private byte[] buf = new byte[1 << 16];
        private int curChar;
        private int numChars;

        public InputReader(InputStream stream) {
            this.stream = stream;
        }

        public int read() {
            if (this.numChars == -1) {
                throw new InputMismatchException();
            } else {
                if (this.curChar >= this.numChars) {
                    this.curChar = 0;

                    try {
                        this.numChars = this.stream.read(this.buf);
                    } catch (IOException var2) {
                        throw new InputMismatchException();
                    }

                    if (this.numChars <= 0) {
                        return -1;
                    }
                }

                return this.buf[this.curChar++];
            }
        }

        public int nextInt() {
            int c;
            for (c = this.read(); isSpaceChar(c); c = this.read()) {
                ;
            }

            byte sgn = 1;
            if (c == 45) {
                sgn = -1;
                c = this.read();
            }

            int res = 0;

            while (c >= 48 && c <= 57) {
                res *= 10;
                res += c - 48;
                c = this.read();
                if (isSpaceChar(c)) {
                    return res * sgn;
                }
            }

            throw new InputMismatchException();
        }

        public static boolean isSpaceChar(int c) {
            return c == 32 || c == 10 || c == 13 || c == 9 || c == -1;
        }

    }
}

