
////////////////////////////////////////////////////////////////////
//       Generate random letter wheels for program testing        //
//       This version ensures the solution is not -1              //
//       [Since purely random values tend to give -1              //
//       Modified from other random test generators, so not pretty//
////////////////////////////////////////////////////////////////////

#include <iostream>
#include <fstream>
using namespace std;

const int MAX_N = 5000;

////////////////////////////////////////////////////////////////////

long randint(long min, long max)
  {
  long range;
  long result;
  long r1;
  long r2;
  long r3;

  r1 = rand() % 1000;
  r2 = rand() % 1000;
  r3 = rand() % 1000;
  result = r1 * 1000000 + r2 * 1000 + r3;  // up to 999,999,999
  range = max - min + 1;
  result = result % range;
  result += min;
  return result;
  }
  

////////////////////////////////////////////////////////////////////

int main(int argc, char *argv[])
  {
  long         i;
  long         maxw;
  long         minw;
  long         maxs;
  long         mins;
  long         n;
  long         x;
  long         y;
  string       a;
  char         b[MAX_N];
  char         c[MAX_N];
  int          offsetb;
  int          offsetc;
  int          spotb;
  int          spotc;
  char         ch_b;
  char         ch_c;

  if (argc != 2)
    {
    cout << "should have exactly one argument, n" << endl;
    exit(1);
    }

  sscanf(argv[1], "%d", &n);
  cout << n << endl;

  for (i = 0; i < n; i++)
    a . push_back('A' + randint(0, 2));

  cout  << a << endl;

  offsetb = randint(n / 4, n / 2);
  offsetc = randint(n / 4, n / 2);
  for (i = 0; i < n; i++)
    {
    spotb = (i + offsetb + n) % n;
    spotc = (i + offsetc + n) % n;

    x = randint(1, 2);
    ch_b = a[i] + x;
    if (ch_b == 'D')
      ch_b = 'A';
    if (ch_b == 'E')
      ch_b = 'B';
    ch_c = 'A' + 'B' + 'C' - a[i] - ch_b;

    b[spotb] = ch_b;
    c[spotc] = ch_c;
    }

  for (i = 0; i < n; i++)
    cout  << b[i];

  cout << endl;
  for (i = 0; i < n; i++)
    cout  << c[i];

  cout << endl;
  cerr << "offset b = " << offsetb << endl;
  cerr << "offset c = " << offsetc << endl;
  }

////////////////////////////////////////////////////////////////////
