import random
import StringIO
from subprocess import call, Popen, PIPE, STDOUT

random.seed('tombraider')

MAX_N = 30

def run(n, arr):
  testcase = StringIO.StringIO()
  testcase.write(print_case(n, arr))
  p = Popen(['./count_states'], stdout=PIPE, stdin=PIPE)
  output = p.communicate(input=testcase.getvalue())[0]
  output_str = output.decode()
  testcase.close()
  return output_str
call(['g++', '-o', 'count_states', './count_states.cpp', '-O3', '-std=c++11'])

random.seed('namerecall')

def rand(a,b):
  return random.randint(a,b)

def print_case(n, arr):
  res = '%d %d\n' % (n, len(arr))
  res += '\n'.join([str(x) for x in arr]) + '\n'
  return res
  
def random_manystates(args):
  n, m = int(args['n']), int(args['m'])
  max_ans = int(args['max_ans']) if 'max_ans' in args else MAX_N
  low = int(args['low']) if 'low' in args else 1
  high = int(args['high']) if 'high' in args else n - 1
  min_states = int(args['min_states'])
  seed = int(args['seed'])
  while True:
    random.seed('tombraider%d' % seed)
    arr = [rand(low, high) for _ in range(m)]
    states, ans = [int(x) for x in run(n, arr).split(' ')]
    if ans <= max_ans and states >= min_states:
      print ('use seed', seed, '#states', states, 'ans', ans)
      break
    else:
      print (seed, states, ans)
      seed += 1
  return print_case(n, arr)
