import java.io.*;
import java.util.*;

public class Arknave {
    static List<Integer>[] tree;
    // node -> list of queries involving this node
    static List<Integer>[] indexes;
    static boolean[] vis;
    static int[] depth;
    static int[] ancestor;

    static int[] uf;

    static int[][] queries;
    static int[] ans;
    static boolean[] foundLCA;

    public static void main(String[] args) throws IOException {
        Scanner scan = new Scanner(System.in);
        int n = scan.nextInt();
        int q = scan.nextInt();
        depth = new int[n];
        ancestor = new int[n];
        vis = new boolean[n];
        uf = new int[n];
        tree = new List[n];
        indexes = new List[n];
        for (int i = 0; i < n; i++) {
            tree[i] = new ArrayList<>();
            indexes[i] = new ArrayList<>();
            uf[i] = i;
        }
        for (int i = 1; i < n; i++) {
            int u = scan.nextInt() - 1;
            int v = scan.nextInt() - 1;
            tree[u].add(v);
            tree[v].add(u);
        }

        queries = new int[q][2];

        for (int i = 0; i < q; i++) {
            queries[i][0] = scan.nextInt() - 1;
            queries[i][1] = scan.nextInt() - 1;
            if (queries[i][0] != queries[i][1]) {
                indexes[queries[i][0]].add(i);
                indexes[queries[i][1]].add(i);
            }
        }

        ans = new int[q];
        foundLCA = new boolean[q];
        dfs(0);

        for (int i = 0; i < q; i++) {
            // System.err.printf("query %d: distance between %d and %d is %d%n", i + 1, queries[i][0] + 1, queries[i][1] + 1, ans[i]);
            long res = n + 1L * ans[i] * (ans[i] + 1) / 2;
            System.out.println(res);
        }
    }

    // Tarjan's offline LCA algorithm
    private static void dfs(int u) {
        vis[u] = true;
        ancestor[u] = u;
        for (int v : tree[u]) {
            if (!vis[v]) {
                depth[v] = depth[u] + 1;
                dfs(v);
                merge(u, v);
                ancestor[find(u)] = u;
            }
        }

        for (int idx : indexes[u]) {
            // System.err.printf("node %d contributes %d to query %d%n", u + 1, depth[u], idx + 1);
            ans[idx] += depth[u];

            int v = queries[idx][0] ^ queries[idx][1] ^ u;
            if (vis[v] && !foundLCA[idx]) {
                int lca = ancestor[find(v)];
                // System.err.printf("lca %d contributes %d to query %d%n", lca + 1, depth[lca], idx + 1);
                ans[idx] -= 2 * depth[lca];
                foundLCA[idx] = true;
            }
        }
    }

    private static int find(int x) {
        return uf[x] = (uf[x] == x) ? x : find(uf[x]);
    }

    private static void merge(int x, int y) {
        int xr = find(x);
        int yr = find(y);
        if (xr == yr) return;
        uf[xr] = yr;
    }
}
