#include <vector>
#include <iostream>
#include <limits.h>
using namespace std ;
const int INF = 1000000000 ;
struct BIT {
   BIT(int n=0) { resize(n) ; }
   void resize(int n) {
      sz = n ;
      arr.resize(4*n+1) ;
      for (auto &v : arr)
         v = INF ;
   }
   int dorange(int a, int b) {
      int r = INF ;
      while (a < b) {
         int lowb = a & -a ;
         if (lowb == 0) {
            lowb = b + b ;
            while (lowb & (lowb - 1))
               lowb &= lowb-1 ;
         }
         while (a + lowb > b)
            lowb >>= 1 ;
         r = min(arr[2*a+lowb], r) ;
         a += lowb ;
      }
      return r ;
   }
   void setv(int a, int v) {
      for (int b=1; b<2*sz; b *= 2) {
         arr[2*a+b] = min(arr[2*a+b], v) ;
         a &= ~b ;
      }
   }
   int sz ;
   vector<int> arr ;
} ;
vector<vector<int>> e ;
vector<int> id, depa ;
int depsz ;
BIT lca ;
void visit(int n, int dep) {
   if (id[n])
      return ;
   id[n] = depsz ;
   depa.push_back(dep) ;
   lca.setv(depsz, dep) ;
   depsz++ ;
   for (auto b : e[n])
      if (id[b] == 0) {
         visit(b, dep+1) ;
         depa.push_back(dep) ;
         lca.setv(depsz, dep) ;
         depsz++ ;
      }
}
int main() {
   int N, Q ;
   cin >> N >> Q ;
   e.resize(N) ;
   for (int i=1; i<N; i++) {
      int a, b ;
      cin >> a >> b ;
      e[a-1].push_back(b-1) ;
      e[b-1].push_back(a-1) ;
   }
   id.resize(N) ;
   lca.resize(2*N) ;
   visit(0, 1) ;
   for (int i=0; i<Q; i++) {
      int a, b ;
      cin >> a >> b ;
      a-- ;
      b-- ;
      int ancdep = lca.dorange(min(id[a], id[b]), 1+max(id[a], id[b])) ;
      int plen = depa[id[a]] + depa[id[b]] - 2 * ancdep ;
      cout << (N + plen * (long long)(plen+1) / 2) << endl ;
   }
}
