#include <iostream>
#include <cstring>
#include <vector>

using namespace std;

using ll = long long;
using vi = vector<int>;

constexpr int MAXN = 2e5 + 5;
constexpr int LOGN = 19;
int n;
vi tree[MAXN];
int depth[MAXN];
int st[LOGN][MAXN];

void dfs(int u) {
    for (int v : tree[u]) {
        if (v == st[0][u]) continue;
        depth[v] = depth[u] + 1;
        st[0][v] = u;
        dfs(v);
    }
}

void gen_st() {
    for (int j = 0; j + 1 < LOGN; ++j) {
        for (int i = 0; i < n; ++i) {
            if (st[j][i] != -1) {
                st[j + 1][i] = st[j][st[j][i]];
            }
        }
    }
}

int lca(int u, int v) {
    if (depth[u] > depth[v]) {
        swap(u, v);
    }

    for (int j = LOGN - 1; j >= 0; --j) {
        if ((depth[v] - depth[u]) & (1 << j)) {
            v = st[j][v];
        }
    }

    if (u == v) {
        return u;
    }

    for (int j = LOGN - 1; j >= 0; --j) {
        if (st[j][u] != st[j][v]) {
            u = st[j][u];
            v = st[j][v];
        }
    }

    return st[0][u];
}

int dist(int u, int v) {
    return depth[u] + depth[v] - 2 * depth[lca(u, v)];
}

inline ll nc2(int k) {
    return 1LL * k * (k - 1) / 2;
}

int main() {
    int q;
    cin >> n >> q;

    for (int i = 1; i < n; ++i) {
        int u, v;
        cin >> u >> v;
        --u; --v;
        tree[u].push_back(v);
        tree[v].push_back(u);
    }

    memset(st, -1, sizeof(st));
    dfs(0);
    gen_st();

    while (q-- > 0) {
        int r1, r2;
        cin >> r1 >> r2;
        --r1; --r2;

        int k = dist(r1, r2);
        cout << n + nc2(k + 1) << '\n';
    }

    return 0;
}
