#!/usr/bin/env python3
import sys

LOGN = 18

input = sys.stdin.readline

def main():
    n, q = map(int, input().split())
    tree = [[] for _ in range(n)]
    for _ in range(n - 1):
        u, v = [int(x) - 1 for x in input().split()]
        tree[u].append(v)
        tree[v].append(u)

    st = [[-1 for _ in range(n)] for _ in range(LOGN)]
    depth = [-1 for _ in range(n)]
    stk = [0]
    depth[0] = 0
    while stk:
        u = stk.pop()
        for v in tree[u]:
            if depth[v] == -1:
                depth[v] = depth[u] + 1
                st[0][v] = u
                stk.append(v)

    for j in range(LOGN - 1):
        for i in range(n):
            if st[j][i] != -1:
                st[j + 1][i] = st[j][st[j][i]]

    def dist(u, v):
        if depth[u] > depth[v]:
            u, v = v, u

        orig_u, orig_v = u, v
        for j in range(LOGN - 1, -1, -1):
            if depth[v] - depth[u] >= (1 << j):
                v = st[j][v]
        if u == v:
            return depth[orig_v] - depth[u]

        for j in range(LOGN - 1, -1, -1):
            if st[j][u] != st[j][v]:
                u, v = st[j][u], st[j][v]

        return depth[orig_u] + depth[orig_v] - 2 * depth[st[0][u]]

    for _ in range(q):
        u, v = [int(x) - 1 for x in input().split()]
        d = dist(u, v)
        print(n + d * (d + 1) // 2)

if __name__ == '__main__':
    main()
