import java.util.*;

public class rootedsubtrees_AN {
  static int N;
  static int[] parents = new int[1 << 18];
  static int[] level = new int[1 << 18];
  static int[][] dp = new int[1 << 18][18];

  static int LCA(int p, int q) {
    if (level[p] < level[q]) {int tmp = p; p = q; q = tmp;}
    int log = 1;
    while ((1 << log) <= level[p]) log++;
    log--;
    for (int i = log; i >= 0; i--) if (level[p] - (1 << i) >= level[q]) p = dp[p][i];

    if (p == q) return p;

    for (int i = log; i >= 0; i--) {
      if (dp[p][i] != -1 && dp[p][i] != dp[q][i]) {
        p = dp[p][i];
        q = dp[q][i];
      }
    }

    return parents[p];
  }

  static int dist(int p, int q) {
    return level[p] + level[q] - 2 * level[LCA(p, q)];
  }

  public static void main(String[] args) {
    var s = new Scanner(System.in);
    N = s.nextInt();
    int Q = s.nextInt();
    ArrayList<Integer>[] adj = new ArrayList[N];
    for (int i = 0; i < N; i++) adj[i] = new ArrayList<>();
    for (int i = 1; i < N; i++) {
      int u = s.nextInt() - 1;
      int v = s.nextInt() - 1;
      adj[u].add(v);
      adj[v].add(u);
    }
    Queue<Integer> queue = new LinkedList<>();
    queue.add(0);
    level[0] = 0;
    Arrays.fill(parents, -1);
    while (!queue.isEmpty()) {
      int next = queue.remove();
      for (int child : adj[next]) {
        if (child > 0 && parents[child] == -1) {
          parents[child] = next;
          level[child] = level[next] + 1;
          queue.add(child);
        }
      }
    }

    for (int i = 0; i < N; i++) {
      for (int j = 0; (1 << j) < N; j++) {
        dp[i][j] = -1;
      }
    }

    for (int i = 0; i < N; i++) dp[i][0] = parents[i];

    for (int j = 1; (1 << j) < N; j++) {
      for (int i = 0; i < N; i++) {
        if (dp[i][j - 1] != -1) dp[i][j] = dp[dp[i][j - 1]][j - 1];
      }
    }

    for (int i = 0; i < Q; i++) {
      int u = s.nextInt() - 1;
      int v = s.nextInt() - 1;
      long d = dist(u, v);
      System.out.println(N - d - 1 + (d + 1) * (d + 2) / 2);
    }
  }
}
