#include <bits/stdc++.h>

using namespace std;

constexpr int MAXN = 255;
using bs = bitset<MAXN>;
vector<int> tree[MAXN];
bs subtree[MAXN][MAXN];

void dfs(int r, int u, int p) {
    for (int v : tree[u]) {
        if (v == p) {
            continue;
        }

        dfs(r, v, u);
        subtree[r][u] |= subtree[r][v];
    }
    subtree[r][u].set(u);
}

int main() {
    int n, q;
    cin >> n >> q;

    for (int i = 1; i < n; ++i) {
        int u, v;
        cin >> u >> v;
        --u; --v;
        tree[u].push_back(v);
        tree[v].push_back(u);
    }

    for (int i = 0; i < n; ++i) {
        dfs(i, i, -1);
    }

    while (q-- > 0) {
        int r1, r2;
        cin >> r1 >> r2;

        --r1; --r2;

        unordered_set<bs> s;
        // always insert the empty set - we erase it at the end
        s.insert(bs());
        for (int u = 0; u < n; ++u) {
            for (int v = 0; v < n; ++v) {
                s.insert(subtree[r1][u] & subtree[r2][v]);
            }
        }

        cout << static_cast<int>(s.size()) - 1 << '\n';
    }

    return 0;
}
