#include <vector>
#include <iostream>
#include <utility>
#include <tuple>

using namespace std;

using ll = long long;
using vi = vector<int>;

constexpr int MAXN = 2e5 + 5;
vi tree[MAXN];
int dist[MAXN];
int ans[MAXN];
vector<pair<int, int>> queries[MAXN];

void dfs(int u, int p) {
    for (int v : tree[u]) {
        if (v == p) continue;
        dist[v] = dist[u] + 1;
        dfs(v, u);
    }
}

inline ll nc2(int k) {
    return 1LL * k * (k - 1) / 2;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int n, q;
    cin >> n >> q;
    for (int i = 1; i < n; ++i) {
        int u, v;
        cin >> u >> v;
        --u; --v;
        tree[u].push_back(v);
        tree[v].push_back(u);
    }

    for (int i = 0; i < q; ++i) {
        int r1, r2;
        cin >> r1 >> r2;
        --r1; --r2;
        if (r1 > r2)
            swap(r1, r2);
        queries[r1].emplace_back(r2, i);
    }

    for (int u = 0; u < n; ++u) {
        if (queries[u].empty())
            continue;
        dist[u] = 0;
        dfs(u, -1);

        for (auto& quer : queries[u]) {
            int v, idx;
            tie(v, idx) = quer;
            ans[idx] = dist[v];
        }
    }

    for (int i = 0; i < q; ++i) {
        cout << n + nc2(ans[i] + 1) << '\n';
    }

    return 0;
}
