#include <vector>
#include <iostream>

using namespace std;

using ll = long long;
using vi = vector<int>;

constexpr int MAXN = 2e5 + 5;
constexpr int INF = 1e9;
vi tree[MAXN];

int dfs(int v, int u, int p) {
    if (u == v) return 0;

    int ans = INF;
    for (int uu : tree[u]) {
        if (uu == p) continue;
        ans = min(ans, 1 + dfs(v, uu, u));
        if (ans < INF)
            break;
    }

    return ans;
}

int dist(int u, int v) {
    return dfs(v, u, -1);
}

inline ll nc2(int k) {
    return 1LL * k * (k - 1) / 2;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int n, q;
    cin >> n >> q;
    for (int i = 1; i < n; ++i) {
        int u, v;
        cin >> u >> v;
        --u; --v;
        tree[u].push_back(v);
        tree[v].push_back(u);
    }

    while (q-- > 0) {
        int r1, r2;
        cin >> r1 >> r2;
        --r1; --r2;

        int k = dist(r1, r2);
        cout << n + nc2(k + 1) << '\n';
    }

    return 0;
}
